# This file was auto-generated by Fern from our API Definition.

import typing

import pydantic
from ...core.pydantic_utilities import IS_PYDANTIC_V2, UniversalBaseModel


class ListCompaniesParams(UniversalBaseModel):
    """
    Input parameters
    """

    ids: typing.Optional[typing.List[str]] = pydantic.Field(default=None)
    """
    Filter companies by multiple company IDs (starts with comp_)
    """

    limit: typing.Optional[int] = pydantic.Field(default=None)
    """
    Page limit (default 100)
    """

    offset: typing.Optional[int] = pydantic.Field(default=None)
    """
    Page offset (default 0)
    """

    plan_id: typing.Optional[str] = pydantic.Field(default=None)
    """
    Filter companies by plan ID (starts with plan_)
    """

    q: typing.Optional[str] = pydantic.Field(default=None)
    """
    Search for companies by name, keys or string traits
    """

    with_subscription: typing.Optional[bool] = pydantic.Field(default=None)
    """
    Filter companies that have a subscription
    """

    without_feature_override_for: typing.Optional[str] = pydantic.Field(default=None)
    """
    Filter out companies that already have a company override for the specified feature ID
    """

    without_plan: typing.Optional[bool] = pydantic.Field(default=None)
    """
    Filter out companies that have a plan
    """

    if IS_PYDANTIC_V2:
        model_config: typing.ClassVar[pydantic.ConfigDict] = pydantic.ConfigDict(extra="allow", frozen=True)  # type: ignore # Pydantic v2
    else:

        class Config:
            frozen = True
            smart_union = True
            extra = pydantic.Extra.allow
